$spacer-tiny: 0.3rem;
$spacer-small: 0.5rem;
$spacer-default: 1rem;
$spacer-large: 2.5rem;

$color-error: #c00;
$color-warning: #cc6200;
$color-ok: #00aa00;
$color-win: #42b983;
$color-info: #0062cc;
$color-base: whitesmoke;
$color-link: #F6BB42;
$color-background-base: #333;
$color-border-base: transparentize($color-base, 0.5);

$font-family-monospace: "Courier New", Courier, monospace;
$font-family-base: "Ubuntu", "Trebuchet MS", Verdana, sans-serif;
$font-size-small: 8pt;
$font-size-smaller: 0.8em;
$font-size-base: 10pt;
$font-size-medium: 12pt;
$font-size-large: 15pt;

$box-shadow: 0 0 10px 0 rgba(black, 0.6);

// Mixins
@import "mixins/respond_to";

// HTML elements
@import 'base';

// App components
@import 'button';
@import 'form';

// Other libs
@import "jigsaw";


.pre-game {
  .preview-area {
    margin: $spacer-default 0;
  }
}

@include respond-to(small-up) {
  .pre-game {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    // Ugly, but *works* for the first row
    grid-template-rows: 370px;
    grid-auto-rows: min-content;
    grid-column-gap: $spacer-default;
    grid-row-gap: $spacer-default;

    .form {
      grid-area: 1 / 1 / 2 / 2;
    }

    .form-actions {
      grid-area: 2 / 1 / 3 / 2;
    }

    .preview-area {
      grid-area: 1 / 2 / 3 / 3;
      margin: 0;
    }
  }
}

.preview {
  max-width: 100%;
  box-shadow: $box-shadow;
}

.score {
  margin: $spacer-default 0;
  text-align: center;
  font-size: $font-size-large;
  font-weight: bolder;
}

.controls {
  @include respond-to('small-up') {
    display: flex;
  }
}

.control-group {
  > button {
    margin-bottom: $spacer-default;
  }

  &:not(:last-child) {
    margin-right: $spacer-default;
  }
}

.win {
  text-align: center;
  padding: $spacer-large;
  color: white;
  background-color: $color-win;
  font-size: xx-large;
  position: fixed;
  top: 50%;
  transform: translateY(-50%);
  left: 0;
  width: 100%;
}

[type="file"] {
  border: 0;
  clip: rect(0, 0, 0, 0);
  height: 1px;
  overflow: hidden;
  padding: 0;
  position: absolute !important;
  white-space: nowrap;
  width: 1px;
}

[type="file"] + label {
  cursor: pointer;
}

.info {
  font-weight: 400;
  padding: $spacer-default;
  margin-bottom: $spacer-default;
  background-color: rgba(white, 0.2);
  color: $color-background-base;
  text-align: center;

  &--error {
    background-color: $color-error;
    color: $color-background-base;
  }

  &--loading {
    background-color: $color-info;
    color: $color-background-base;
    font-weight: 400;
    padding: $spacer-default;
  }
}


.game-wrapper {
  box-shadow: $box-shadow;

  // Custom states
  &.hide {
    .jigsaw-cell.bad {
      opacity: 0;
    }
  }

  &.transparentize {
    .jigsaw-cell.bad {
      opacity: 0.5;
    }
  }

  &.outline {
    .jigsaw-cell.bad {
      $cell-padding: $spacer-tiny;
      $cell-border: 3px;

      &:before {
        position: absolute;
        content: '';
        height: calc(var(--cell-size) - #{2 * $cell-padding} - #{2 * $cell-border});
        width: calc(var(--cell-size) - #{2 * $cell-padding} - #{2 * $cell-border});
        margin-top: $cell-padding;
        margin-left: $cell-padding;
        border: $cell-border solid rgba($color-error, .5);
        z-index: 10;
      }
    }
  }
}

.modal {
  background-color: $color-background-base;
  max-width: 800px;
  margin: $spacer-large;
  padding: $spacer-default;
  box-shadow: $box-shadow;
  z-index: 1001;

  &-footer {
    margin-top: $spacer-default;
    text-align: right;
  }

  &-wrapper {
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    background-color: rgba($color-background-base, .8);
  }

  @include respond-to('small-up') {
    margin-left: 50vw;
    margin-top: 50vh;
    transform: translateY(-50%) translateX(-50%);
  }
}

.positions-block {
  font-family: $font-family-monospace;
  max-height: 20vh;
  overflow-y: auto;
}

.drop-zone {
  border: 2px dashed rgba($color-border-base, 0.3);
  text-align: center;
  padding: $spacer-large;

  &--active {
    border-color: $color-info;
    background-color: rgba($color-info, 0.3);
  }
}
